<?php

// add to after single product
add_action( 'woocommerce_after_single_product_summary', 'mrpbs_templates', 5);

// template
if( !function_exists( 'mrpbs_templates' ) ) {
    function mrpbs_templates() {

        // get value mrpbs settings
        $mrpbs_title = esc_attr( get_option('mrpbs_title') );
        if( empty($mrpbs_title) ) $mrpbs_title = esc_attr__( 'Segments Product', 'moc-related-product-by-segments' );

        $mrpbs_by = esc_attr( get_option('mrpbs_by') );
        if( empty($mrpbs_by) ) $mrpbs_by = esc_attr__( '1', 'moc-related-product-by-segments' );

        $mrpbs_number = esc_attr( get_option('mrpbs_number') );
        if( empty($mrpbs_number) ) $mrpbs_number = esc_attr__( '4', 'moc-related-product-by-segments' );

        $mrpbs_segments = esc_attr( get_option('mrpbs_segments') );
        if( empty($mrpbs_segments) ) $mrpbs_segments = esc_attr__( '10', 'moc-related-product-by-segments' );

        // get price
        global $post;
        $price = get_post_meta( $post->ID, '_price', true);
        $price_max = (int)($price + $mrpbs_segments);
        $price_min = (int)($price - $mrpbs_segments);

        // create agrs
        $agrs = array(
            'post_type'                 => 'product',
            'meta_query' => array (
                'relation'              => 'AND',
                array(
                    'key'               => '_price',
                    'value'             => $price_max,
                    'compare'           => '<=',
                ),
                array(
                    'key'               => '_price',
                    'value'             => $price_min,
                    'compare'           => '>=',
                ),
            ),
            'posts_per_page'            => $mrpbs_number,
            'post__not_in'              => array ($post->ID),
            'ignore_sticky_posts'       => 1
        );

        if($mrpbs_by == '0') {
            $terms = wp_get_post_terms( $post->ID, 'product_tag' );
            foreach ( $terms as $term ) $term_array[] = $term->term_id;
            $agrs['tax_query'] = array(
                array(
                    'taxonomy'          => 'product_tag',
                    'field'             => 'id',
                    'terms'             =>  $terms,
                ),
            );
        } else {
            $terms = wp_get_post_terms( $post->ID, 'product_cat' );
            foreach ( $terms as $term ) $term_array[] = $term->term_id;
            $agrs['tax_query'] = array(
                array(
                    'taxonomy'          => 'product_cat',
                    'field'             => 'id',
                    'terms'             =>  $term_array,
                ),
            );
        }

        // create new query
        $mrpbs_query = new WP_Query($agrs);

        // display list product
        if( $mrpbs_query->have_posts() ) :
            echo '<div id="mrpbs_product" class="related products">';
                echo '<h2 class="mrpbs_title">' . esc_attr( $mrpbs_title ) . '</h2>';
                do_action( 'woocommerce_before_shop_loop' );
                	woocommerce_product_loop_start();
                		while ($mrpbs_query->have_posts()): $mrpbs_query->the_post();
                			do_action( 'woocommerce_shop_loop' );
                			wc_get_template_part( 'content', 'product' );
                		endwhile;
                	woocommerce_product_loop_end();
            	do_action( 'woocommerce_after_shop_loop' );
            echo '</div>';
        endif;
        wp_reset_postdata();
    }
}
